Bug 41375

Summary: Using same SSL Certificate with different ServerName causes crash/coredump
Product: Apache httpd-2 Reporter: Brendan Boyd <asfbugzilla>
Component: mod_sslAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED LATER    
Severity: minor Keywords: ErrorMessage, MassUpdate
Priority: P4    
Version: 2.2.3   
Target Milestone: ---   
Hardware: PC   
OS: FreeBSD   

Description Brendan Boyd 2007-01-15 16:46:35 UTC
Albeit probably not best practice, I was in the throws of testing things and
just happend to try and use the same SSLCertificateFile for two different
VirtualHost servers running on two different ports, with the same ServerName.

Both worked fine untill I changed the ServerName of one of them in the config
file, the server would then crash on start up with practically no debug
information or any pointers to a relevant cause. After a fair bit of fiddling
about I worked out that the ServerName change was the cause. I changed to using
two different certificates and the problem went away.

[Wed Dec 27 02:45:18 2006] [info] Init: Seeding PRNG with 136 bytes of entropy
[Wed Dec 27 02:45:18 2006] [info] Init: Generating temporary RSA private keys
(512/1024 bits)
[Wed Dec 27 02:45:19 2006] [info] Init: Generating temporary DH parameters
(512/1024 bits)
[Wed Dec 27 02:45:19 2006] [info] Init: Initializing (virtual) servers for SSL
[Wed Dec 27 02:45:19 2006] [info] Server: Apache/2.2.3, Interface:
mod_ssl/2.2.3, Library: OpenSSL/0.9.7c
[Wed Dec 27 02:45:19 2006] [info] mod_unique_id: using ip addr xxx.xxx.xxx.xxx
[Wed Dec 27 02:45:20 2006] [info] Init: Seeding PRNG with 136 bytes of entropy

Is all that would be written to the main error log.

With:

[Wed Dec 27 02:45:19 2006] [info] Configuring server for SSL protocol
[Wed Dec 27 02:45:19 2006] [debug] ssl_engine_init.c(405): Creating new SSL
context (protocols: SSLv2, SSLv3, TLSv1)
[Wed Dec 27 02:45:19 2006] [debug] ssl_engine_init.c(729): Configuring RSA
server certificate
[Wed Dec 27 02:45:19 2006] [warn] RSA server certificate CommonName (CN) `xxx'
does NOT match server name!?
[Wed Dec 27 02:45:19 2006] [debug] ssl_engine_init.c(768): Configuring RSA
server private key

Being written to both of the relevant VirtualHost error logs.

This may well not be a bug, but an intended feature, could possibly do with a
"don't be silly!" debug message ;)

Regards,


Brendan Boyd
Comment 1 Joe Orton 2007-09-18 03:08:08 UTC
What does "crash on startup" mean, exactly?  A segfault?
Comment 2 William A. Rowe Jr. 2018-11-07 21:09:38 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.